; NOPRINT.COM      Version 4.2
; Disables Shift-PrtSc and Ctrl-PrtSc.
; Checks printer status, beeps if printer is not ready.

; Checks for prior installation by looking for four words of code.
; Uses interrupt 10h to generate beep.

; Written in CHeap ASseMbler format by :
;       L. R. Holliday
;       218 Virginia
;       Ponca City, Oklahoma 74601

noprint  proc   far
         JMPS   init
add_bx   DS     2,0
add_es   DS     2,0
flag     db     0fh
kbint    STI
         PUSH    AX
         push    dx
         push    bx
         push    cx
         IN      AL,60h
         CMP     AL,37h
         JNZ     exit
         MOV     AH,02
         INT     16h
         TEST    AL,07
         JZ      exit
         mov     dx,0000
         mov     ah,02
         int     17h
         cmp     ah,90h
         jnz     kbreset
         jmps    exit
kbreset  mov     ah,0eh
         mov     cx,0001
         mov     al,07
         int     10h
         IN      AL,61h
         MOV     AH,AL
         OR      AL,80h
         OUT     61h,AL
         MOV     AL,AH
         OUT     61h,AL
         CLI
         MOV     AL,20h
         OUT     20h,AL
         pop     cx
         pop     bx
         pop     dx
         POP     AX
         IRET
exit     pop     cx
         pop     bx
         pop     dx
         POP     AX
         SEG     CS
         JMPF    add_bx
init     mov     ah,30h
         int     21h
         cmp     al,2
         jae     check
         mov     dx,offset(err_msg2)
         jmps    msg_out
check    mov     dx,offset(kbint)
         mov     ax,cs
         mov     es,ax
nextseg  dec     ax
         mov     ds,ax
         mov     si,dx
         mov     di,dx
         mov     cx,0004h
         cld
         repz
         cmpsw
         jnz     notfound
         cmpb    flag,0fh
         jnz     installed
notfound cmp     ax,0001h
         jnz     nextseg
install  seg     cs
         movb    flag,00h
         MOV     AX,3509h
         INT     21h
         seg     cs
         MOV     add_bx,BX
         seg     cs
         MOV     add_es,ES
         push    cs
         pop     ds
         MOV     DX,offset(kbint)
         MOV     AX,2509h
         INT     21h
         mov     dx,offset(inst_msg)
         mov     ah,9
         int     21h
         MOV     DX,offset(init)
         INT     27h
installed mov    dx,offset(err_msg1)
msg_out  mov     ah,9
         push    cs
         pop     ds
         int     21h
         int     20h
end      endp

inst_msg db  13,10,'    NOPRINT.COM  --  Version  4.2',13,10
         db  13,10,'    by L. R. Holliday',13,10
         db  13,10,'    Memory-Resident Portion Installed',13,10
         db  13,10,'    Shift-PrtSc and Ctrl-Prtsc Disabled'
         db  '  IF   Printer is  NOT  Ready',13,10
         db  '                                       '
         db  '  --',13,10,36

err_msg1 db  13,10,'    NOPRINT.COM  --  Version  4.2',13,10
         db  13,10,'    by L. R. Holliday',13,10
         db  07,13,10,'    --- Already Installed ---',13,10,36

err_msg2 db  13,10,'    NOPRINT.COM  --  Version  4.2',13,10
         db  13,10,'    by L. R. Holliday',13,10
         db  07,13,10,'    --- Wrong Dos Version ---',13,10,36
